-- File		: ASPToVB.e
-- Author	: Tone koda  e-mail: tone.skoda@siol.net
-- Created	: 19. november 2000
-- Purpose	:	translates .asp file to Visual Basic file,
--				from which you can make VB  dll.
--				It makes pure asp code from asp file, which
--				can have also HTML code in it
--				by converting that HTML code to
--				response.write() statements.
--				Some special things 
--				of translated code may need to 
--				be corrected or added by hand by yourself.
--ASPToVB_



with trace

include Skoda\TSFile.e
include Skoda\TSString.e

global integer ToVB
ToVB=1

global sequence TheResponse

global constant VBnl="\" & chr(13) & \""	--visual basic new line
global constant VBtabChr="\" & chr(9) & \""	--visual basic tab




---------------------------------------------------------------------------
procedure error(sequence say)
	puts(1,"\nASPToVB Error: " & say)
end procedure


---------------------------------------------------------------------------
--INDEPENDENT
--returns:
--1. parsed text
--2. spaces at start of line, not newlines
--from 
--	 var i=<%=vbvar%> & "a word"
--returns
--"\t var i=" & vbvar & chr(34) & "a word" & chr(34)
--
--arg. whoseTabs :	if this 0 then tabs are from html,
--					if 1 then tabs are from asp code
--					example:"		Text"
--					is translated:
--					1.if whoseTabs=0:
--					MyResponse.Write("\t\tText")
--					1.if whoseTabs=1:
--							MyResponse.Write("Text")
---------------------------------------------------------------------------
function parseHTMLLine(sequence line,integer whoseTabs)
	integer c
	sequence r			--parsed line
	sequence spaces		--spaces at start
	atom inVB			--if in <%= %> then position of start, else 0
	integer nextc,prevc,nextnextc
	sequence vbCode		--code inside <%= %>
	integer inStr		--if we are in string : " in here "
	integer overSpaces	--if true then we are over starting spaces
	integer HTMLtabs
	integer VBtabs

	if(whoseTabs=0 or whoseTabs=2)then
		HTMLtabs=true
	end if

	if(whoseTabs=1 or whoseTabs=2)then
		VBtabs=true
	end if


	r=""
	inVB=0
	prevc=0
	nextc=0
	inStr=false
	spaces=""
	overSpaces=false

	for i=1 to length(line) do
		c=line[i]

		if(i+1<=length(line))then
			nextc=line[i+1]
		end if
		if(i+2<=length(line))then
			nextnextc=line[i+2]
		end if

		if(overSpaces=false)then
			if(c='\t' or c=' ' or c='\n')then
				--if(c!='\n')then
					spaces&=c
				--end if
			else
				overSpaces=true
			end if
			
		end if


		--quote character
		if(c='"' or c='\'') then
			if(inVB=0)then
				if(c='"')then
					r&="\"" & " & chr(34) & " & "\""
				else
					r&="\"" & " & chr(39) & " & "\""
				end if
			end if

			if(inStr)then
				inStr=false
			else
				inStr=true
			end if

		--tab character
		--elsif(c='\t' and inStr=false and HTMLtabs)then
		elsif(c='\t' and HTMLtabs)then
			if(inVB=0)then
				r&=VBtabChr --"\\t"
			end if

		--newline character
		--elsif(c='\n' and inStr=false)then
		elsif(c='\n')then
			if(inVB=0)then
				r&=VBnl --"\\n"
			end if

		--<%=
		--elsif(c='<' and nextc='%' and nextnextc='=' and inStr=false)then
		elsif(c='<' and nextc='%' and nextnextc='=')then
			inVB=i
		
		--%>
		--elsif (c='>' and prevc='%' and inStr=false) then
		elsif (c='>' and prevc='%') then
			vbCode=mid(line,inVB+3,i-2)
			r&="\" & " & vbCode & " & \""
			inVB=0
			
		else
			if(inVB=0)then
				if(VBtabs)then
					if(overSpaces or c='\n')then
						r&=c
					end if
				else
					r&=c
				end if
			end if
		end if

		prevc=c
	end for

	if(HTMLtabs and overSpaces=false)then
		r=""
	end if

	return {r,spaces}
end function

---------------------------------------------------------------------------
--main function
--if dstFile already exists it overwrites it
--arg. whoseTabs :	if this 0 then tabs are from html,
--					if 1 then tabs are from asp code
--					if 2 then from both
--					example:"		Text"
--					is translated:
--					1.if whoseTabs=0:
--					MyResponse.Write("\t\tText")
--					1.if whoseTabs=1:
--							MyResponse.Write("Text")
--arg. toVB	:		-if false then
--					translated file is such that
--					it can be used as an asp page.
--					-if true it is translated so
--					that it is used as a VB dll source file.
---------------------------------------------------------------------------
global procedure ASPToVB_Do(sequence srcFile,sequence dstFile, integer whoseTabs,integer toVB)
	sequence s			-- source
	sequence r			-- result
	integer dstfn		-- destination file
	integer c			-- current character
	integer prevc		-- previous character
	integer nextc		-- next character
	integer inASP		-- are we inside <% %>
	sequence oneLine	-- one already translated line
	atom lastLeft		-- last "<%"
	atom lastRight		-- last "%>"
	atom lastNl			-- last '\n'
	atom inWriteASP		-- if we are in <%= %> start of it else 0
	sequence parsedHTMLLine
	sequence tmp
	sequence spaces
	integer HTMLtabs
	integer VBtabs

	if(whoseTabs=0 or whoseTabs=2)then
		HTMLtabs=true
	end if

	if(whoseTabs=1 or whoseTabs=2)then
		VBtabs=true
	end if





	spaces=""
	ToVB=toVB

	if ToVB then
		TheResponse="MyResponse"
	else
		TheResponse="Response"
	end if
	
	s=readFile(srcFile)
	

	if ToVB then
		r="'This file was translated from .ASP file to VB file"
		r&="\n'with ASPToVB Euphoria program."
		r&="\n\n"
		r&="\nPrivate MyScriptingContext As ASPTypeLibrary.ScriptingContext"
		r&="\nPrivate MyRequest As ASPTypeLibrary.Request"
		r&="\nPrivate MyResponse As ASPTypeLibrary.Response"
		r&="\nPrivate MyServer As ASPTypeLibrary.Server"
		r&="\n"
		r&="\nPublic Sub OnStartPage(PassedScriptingContext As ScriptingContext)"
		r&="\n\tSet MyScriptingContext = PassedScriptingContext"
		r&="\n\tSet MyRequest = MyScriptingContext.Request"
		r&="\n\tSet MyResponse = MyScriptingContext.Response"
		r&="\n\tSet MyServer = MyScriptingContext.Server"    
		r&="\nEnd Sub"
		r&="\n"
		r&="\nPrivate Sub Class_Terminate()"    
		r&="\n\tSet MyRequest = Nothing"
		r&="\n\tSet MyResponse = Nothing"
		r&="\n\tSet MyServer = Nothing"
		r&="\nEnd Sub"
	else
		r="<%"
		r&="\n'This file was translated from .ASP file to .ASP file"
		r&="\n'so that it contains no HTML code"
		r&="\n'with ASPToVB Euphoria program."
		r&="\n\n"
	end if



	prevc=0	
	inASP=false
	lastLeft=1
	lastRight=1
	lastNl=1
	nextc=0
	inWriteASP=0

	--main loop
	for i=1 to length(s) do
		c=s[i]
		
		if(i<length(s))then
			nextc=s[i+1]
		else
			nextc=0
		end if
		
		--"<%"
		if (c='%' and prevc='<' and nextc!='=') then
			inASP=true
			lastLeft=i-1
			
			if(lastRight+2<=length(s) and lastLeft-2<=length(s)
				and lastRight+2>0 and lastLeft-2>0) then
			
				if(lastRight>lastNl)then	
					
					tmp=parseHTMLLine(mid(s,lastRight+2,lastLeft-1),whoseTabs)
					parsedHTMLLine=tmp[1]
					
					if(VBtabs)then
						spaces=tmp[2]
					else
						spaces=""
					end if

					r&=spaces

					if(length(parsedHTMLLine)) then
						r&=TheResponse & ".Write( " & "\"" 
							&  parsedHTMLLine
							& "\"" & " )"						
					end if
				else
					tmp=parseHTMLLine(mid(s,lastNl,lastLeft-1),whoseTabs)
					parsedHTMLLine=tmp[1]

					if(VBtabs)then
						spaces=tmp[2]
					else
						spaces=""
					end if

					r&=spaces

					--trace(1)

					if (length(parsedHTMLLine))then
						r&=TheResponse & ".Write( " 
							& "\"" & parsedHTMLLine
							& "\"" & " )"
					end if
				end if
			end if

		--"<%="
		elsif (c='%' and prevc='<' and nextc='=') then
			inWriteASP=i-1
		
		--"%>"
		elsif (c='>' and prevc='%') then
			
			-- end of <% %> block
			if(inWriteASP=0)then
				inASP=false
				lastRight=i-1

				
				r&=TSStr_Replace_DontMatchCase(mid(s,lastLeft+2,lastRight-1),"response",TheResponse)

			-- end of <%= %> block
			else
				inWriteASP=0
			end if

		elsif (c='\n') then
			if(inASP=false)then
				if(lastRight>lastNl)then
					tmp=parseHTMLLine(mid(s,lastRight+2,i-1),whoseTabs)
					parsedHTMLLine=tmp[1]

					if(VBtabs)then
						spaces=tmp[2]
					else
						spaces=""
					end if

					r&=spaces
					
					if(length(parsedHTMLLine)) then
						r&=TheResponse & ".Write( " & "\""
							& parsedHTMLLine & "\"" & " )"
					end if
				else
					tmp=parseHTMLLine(mid(s,lastNl,i-1),whoseTabs)
					parsedHTMLLine=tmp[1]

					if(VBtabs)then
						spaces=tmp[2]
					else
						spaces=""
					end if

					r&=spaces

					if(length(parsedHTMLLine)) then
						r&=TheResponse & ".Write( " & "\""
							& parsedHTMLLine & "\"" & " )"
					end if
				end if
			end if
			lastNl=i
		end if

		prevc=c
	end for

	if toVB=0 then --this will be asp file
		r&="\n%>"
	end if

	--write translated code to file
	dstfn=open(dstFile,"w")
	if(dstfn=-1)then
		error("Can't open or create file " & dstFile & " for writing.")
	end if
	puts(dstfn,r)

end procedure