
global integer TSDebug_fn,TSDebug_do

TSDebug_fn=0 --CHANGE this to 1 to DO debug or 0 to NOT debug

--clear file
if TSDebug_fn then
	TSDebug_fn=open("tsdebug.txt","w")
	close(TSDebug_fn)

	TSDebug_fn=open("tsdebug.txt","a")
end if

---------------------------------------------------------------------------
global procedure debugf(sequence format,sequence data)
	if TSDebug_fn then	
		printf(TSDebug_fn,format,data)
	end if
end procedure

---------------------------------------------------------------------------
global procedure debugfs(sequence string)
	if TSDebug_fn then
		printf(TSDebug_fn,"\n%s",{string})
	end if
end procedure

---------------------------------------------------------------------------
global procedure ts(object what)
	printf(1,"\n%s",{what})
end procedure

---------------------------------------------------------------------------
global function print_format( object o )

    -- returns object formatted for wPrint
    sequence s

    if atom( o ) then
        -- number
		if o >= ' ' and o <= '}' then
			--return sprintf( "%d'%s'", {o,o} )
			return sprintf( "%s", o )
		else			
			return sprintf( "%d", o )
		end if
    else
        -- list
        s = "{"
        for i = 1 to length( o ) do
            s = s & print_format( o[i] )
            if i < length( o ) then
                s = s & ","
            end if
        end for
        s = s & "}"
        return s
    end if

end function


--for letters gives also its ansi code
---------------------------------------------------------------------------
global function print_format_perfect( object o )

    -- returns object formatted for wPrint
    sequence s

    if atom( o ) then
        -- number
		if o >= ' ' and o <= '}' then
			return sprintf( "%d'%s'", {o,o} )
			--return sprintf( "%s", o )
		else			
			return sprintf( "%d", o )
		end if
    else
        -- list
        s = "{"
        for i = 1 to length( o ) do
            s = s & print_format_perfect( o[i] )
            if i < length( o ) then
                s = s & ","
            end if
        end for
        s = s & "}"
        return s
    end if

end function


---------------------------------------------------------------------------
global function print_format_numbers( object o )

    -- returns object formatted for wPrint
    sequence s

    if atom( o ) then
        -- number		
		return sprintf( "%d", o )
    else
        -- list
        s = "{"
        for i = 1 to length( o ) do
            s = s & print_format_numbers( o[i] )
            if i < length( o ) then
                s = s & ","
            end if
        end for
        s = s & "}"
        return s
    end if

end function


--retunrs {text,pos,colors}
---------------------------------------------------------------------------
global function print_format_colored( object o )

    -- returns object formatted for wPrint
    sequence s
	sequence pos
	sequence colors,pf,fpos,fcolors
	atom prevc

    if atom( o ) then        
		if o >= ' ' and o <= '}' then			
			return {sprintf( "'%s'", o ),{1},{YELLOW}}
		else --number			
			return {sprintf( "%d", o ),{1},{RED}}
		end if
    else
        -- list
        s = "{"
		pos={}
		colors={}
		prevc=-1
        for i = 1 to length( o ) do
			pf=print_format_colored( o[i] )

--			showw("pf in for",pf)

			--new color
			if prevc=-1 or prevc!=pf[3][length(pf[3])]then
				colors=append(colors,pf[3][length(pf[3])])
				pos=append(pos,i)
--				showw("i",i)
--				showw("added color",colors)
--				showw("added pos",pos)
				prevc=pf[3][length(pf[3])]								
			end if

            s = s & pf[1]			

			

            if i < length( o ) then
                s = s & ","
            end if
        end for
        s = s & "}"
        return {s,pos,colors}
    end if

end function


---------------------------------------------------------------------------
global procedure show(sequence name,object o)	
	printf(1,"\n%s:%s",{name,print_format(o)})
end procedure

---------------------------------------------------------------------------
global procedure showw(sequence name,object o)
	printf(1,"\n%s:%s",{name,print_format(o)})	
	
--	sequence pfc
--	pfc=print_format_colored(o)
--	ts("pfc[1]=")
--	ts(pfc[1])
--	ColoredTextOut(sprintf("\n%s:%s",{name,pfc[1]})
--		,pfc[2],pfc[3])

	wait()
end procedure



---------------------------------------------------------------------------
global procedure showMeStrings(sequence list)
	for i=1 to length(list) do
		textout("\n%s%d%s%s",{"list[",i,"]=",list[i]})
	end for
end procedure

---------------------------------------------------------------------------
global procedure showMeStringsWait(sequence list)
	for i=1 to length(list) do
		textoutwait("\n%s%d%s%s",{"list[",i,"]=",list[i]})
	end for
end procedure

---------------------------------------------------------------------------
global procedure showMeStringsWaitEnd(sequence list)
	for i=1 to length(list) do
		textoutwait("\n%s%d%s%s%s",{"list[",i,"]=",list[i],"End"})
	end for
end procedure

---------------------------------------------------------------------------
global procedure shown(sequence name,object o)	
	printf(1,"\n%s:%s",{name,print_format_numbers(o)})
end procedure

---------------------------------------------------------------------------
global procedure shownf(integer fn,sequence name,object o)
	printf(fn,"\n%s:%s",{name,print_format_numbers(o)})
end procedure

---------------------------------------------------------------------------
global procedure showf(integer fn,sequence name,object o)
	printf(fn,"\n%s:%s",{name,print_format(o)})
end procedure

---------------------------------------------------------------------------
global procedure showpf(integer fn,sequence name,object o)
	printf(fn,"\n%s:%s",{name,print_format_perfect(o)})
end procedure




--pos holds positions where colors change
--colors are
---------------------------------------------------------------------------
global procedure ColoredTextOut(sequence text,sequence pos,sequence colors)
	atom pp	

	ts("colored tex outt:")
	?pos
	?colors

	for i=1 to length(text) do
		pp=find(i,pos)
		if pp then
			text_color(colors[pp])
		end if

		puts(1,text[i])

	end for
end procedure





---------------------------------------------------------------------------
procedure make_sound(atom pitch,atom seconds)
	atom timecount
	timecount = time()
	sound(pitch)
	while time() - timecount < seconds do end while
	sound(0)
end procedure



---------------------------------------------------------------------------
global function print_format_doubles( object o )

    -- returns object formatted for wPrint
    sequence s

    if atom( o ) then
        -- number		
		return sprintf( "%f", o )
    else
        -- list
        s = "{"
        for i = 1 to length( o ) do
            s = s & print_format_doubles( o[i] )
            if i < length( o ) then
                s = s & ","
            end if
        end for
        s = s & "}"
        return s
    end if

end function



--displays double numbers
---------------------------------------------------------------------------
global procedure showd(sequence name,object o)	
	printf(1,"\n%s:%s",{name,print_format_doubles(o)})
end procedure
