-- File		: TSFile.e
-- Author	: Tone koda  e-mail: tone.skoda@siol.net
-- Purpose	: (independent OS?) file handling routines


--TSFile_

include file.e
include get.e
include Skoda\TSdos.e
include Skoda\TS_misc.e
include Skoda\TSAtoB.e
--include Skoda\Error.e
include Skoda\TS_misc.e





 

--global function readFile( sequence fName )
--global function FileLength(integer fn)
--global function readFileSlice(integer file,atom first,atom last)


procedure error(sequence say)
	puts(1,"\nTSFile error: " & say)
end procedure



-----------------------------------------------------------------------------
--reads whole file
global function readFile( sequence fName )

    integer handle
    sequence out
    object data

    -- open the file
    handle = open( fName, "r" )

	if handle=-1 then
		error("readFile : Can't open file " & fName)
	end if

    -- initialize data
    out = {}
    
    while 1 do
        -- read a line of text
        data = gets( handle ) 
        
        -- end of file?
        if atom( data ) then
            exit
        end if

        -- remove line feed        
--        if data[length(data)] = '\n' then
--            data[length(data)] = ' '
--        end if
        
        -- add to data
        --out = append( out, data )
	out=out & data
	
	
--	textout("\n%s",{"out="})
--	textout("%s",{out})
--	textout("\n%s",{"data="})
--	textout("%s",{data})
--	wait()
        
    end while

    -- close the file
    close( handle )

    -- return the text    
    return out
    
end function


--global procedure WriteFile(sequence fname,

--returns file length or -1 if unsuccesful
global function FileLength(integer fn)
	if seek(fn, -1) then
return -1
    end if

	return where(fn)
end function


global function readFileSlice(integer file,atom first,atom last)
	sequence ret
	atom isok
	isok=seek(file,first)
	ret=get_bytes(file,last-first)

	return ret
end function

--return 1 if file exists else 0
global function TSFile_exist(sequence fn)
        integer a
        a=open(fn,"r")
        if a=-1 then
           --not found
           a=0
        else
           --found
           close(a)
           a=1
        end if
        return a
end function

global procedure TSFile_clearfile(sequence fn)
        integer a
        a=open(fn,"w")

        close(a)
end procedure




----------------------------------------------------------------------------
global function tsdir_list( sequence currentDir )

    object tmp
    sequence s

    -- return a list of directories

    s = {}
    tmp = dir( currentDir )
    if compare( tmp, -1 ) = 0 then
        -- current directory is BAD
        return { "" }
    end if

    -- parse list
    for i = 1 to length( tmp ) do		
        if compare( "d", tmp[i][D_ATTRIBUTES] ) = 0 then
			--show("tmp[i][D_NAME]",tmp[i][D_NAME])
--			if equal(tmp[i][D_NAME],".")=0 
--			and equal(tmp[i][D_NAME],"..")=0 then
				s = append( s, tmp[i][D_NAME] )
--			end if
        end if
    end for

    -- add drives
    s =  sort_no_case_sens( s ) -- & floppies() & hard_drives()

    return s

end function

--returns:
--1.dir names
--2.file names
global function tsdir_files_list( sequence currentDir )

    object tmp
    sequence s,filelist

    -- return a list of directories

    s = {}
	filelist={}
    tmp = dir( currentDir )
    if compare( tmp, -1 ) = 0 then
        -- current directory is BAD
        return { "" }
    end if

    -- parse list
    for i = 1 to length( tmp ) do		
        if compare( "d", tmp[i][D_ATTRIBUTES] ) = 0 then
			--show("tmp[i][D_NAME]",tmp[i][D_NAME])
--			if equal(tmp[i][D_NAME],".")=0 
--			and equal(tmp[i][D_NAME],"..")=0 then
				s = append( s, tmp[i][D_NAME] )
--			end if
		else
			filelist=append(filelist,tmp[i][D_NAME] )
        end if
    end for

    -- add drives
    s =  sort_no_case_sens( s ) -- & floppies() & hard_drives()
	filelist =  sort_no_case_sens( filelist )

    return {s,filelist}

end function



--if any directory in directory
global function IsDirInDir( sequence currentDir )

    object tmp
    sequence s

    s = {}
    tmp = dir( currentDir )
    if compare( tmp, -1 ) = 0 then
        -- current directory is BAD
        return 0
    end if

    -- parse list
    for i = 1 to length( tmp ) do
	--printf(1,"\n%s",{tmp[i][D_NAME]})
        if compare( "d", tmp[i][D_ATTRIBUTES] ) = 0 then
		if equal(tmp[i][D_NAME],".")=0 
		and equal(tmp[i][D_NAME],"..")=0 then
	            return 1
		end if
        end if
    end for

    return 0
end function


--returns sequence of lines of text read from file
--removes '\n'
--if file does not exists returns empty {{}}
global function TSFile_ReadLines(sequence fName)
	
    integer handle, at    
    sequence shortName    
    object data
	sequence file

	        -- open the file
        handle = open( fName, "r" )

	if handle=-1 then
		return {{}}
	end if
    
        -- initialize data
        file = {}
        
        while 1 do
            -- read a line of text
            data = gets( handle ) 
--			show("data",data)
--			wait()
            
            -- end of file?
            if atom( data ) then				
                exit
            end if
    
            -- remove line feed        
            if data[length(data)] = '\n' then
                data=data[1..length(data)-1]
--			else
--				data={}
            end if
            -- add to data
--			show("adding data",data)
            file = append( file, data )
            
        end while

--		show("file",file)
    
        -- close the file
        close( handle )
    
    return file
end function

--saves lines of text to file
--previous data is overwritten
--if file doesnt exist it is created
--argument txtLns : lines of text
global procedure TSFile_WriteLines(sequence fName,sequence txtLns)
	integer fn
	--atom t
	fn=open(fName,"w")
	if fn=-1 then
		error("TSFile_WriteLines cant open file " & fName & " for writing.")
	end if
	for i=1 to length(txtLns) do
		--t=i
		puts(fn,txtLns[i])
		puts(fn,"\n")
	end for

	--ts("saved lines " & itoa(t))
	close(fn)
end procedure


--by jiri babor
global function fast_file_read(sequence inFile)
    sequence buffer
    integer fi,len,o

    fi = open(inFile, "rb")
    if fi = -1 then
        puts(1, "Input file " & inFile & " not found! Terminating.")
		waits()
        abort(1)		
    end if

    o = seek(fi,-1)         -- go to end of input file
    len = where(fi)         -- get length of input file in bytes
    o = seek(fi,0)          -- go back to beginning of input file
    buffer = repeat(0, len) -- initialize your buffer
    for i=1 to len do
        buffer[i] = getc(fi)
    end for
    close(fi)

    return buffer
end function


--sorts data you get with dir() function
--returns : 
--1.directories datas (sorted ascending)
--2.files datas (sorted ascending)
--leaves out ".." and "."
---------------------------------------------------------------------------
global function TSFile_SortDirData(sequence data)
	sequence dirs,files
	dirs={}
	files={}

	for i=1 to length(data)do
--		show("data[i]",data[i])
--		wait()
		if find('d',data[i][2])then --if directory
--			show("data[i][2]",data[i][2])
--			wait()
			if equal(data[i][1],".")=false and equal(data[i][1],"..")=false then
				dirs=append(dirs,data[i])
			end if
		else
--			show("file",data[i])
--			wait()
			files=append(files,data[i])
		end if
	end for
	
	return {sort_no_case_sens(dirs),
		sort_no_case_sens(files)}
end function


--returns "txt" from "file.txt" or "c:\file.txt"
global function GetFileExtension(sequence path)
	atom p
	integer char
	
	for i=length(path) to 1 by -1 do
		char=path[i]
		if char='.' then
			return path[i+1..length(path)]
		end if
	end for

	return ""
end function