--File : TSString.e
--Author : Tone koda  e-mail: tone.skoda@siol.net
--Purpose : String routines
--TSStr_

with trace

include Ctype.e
include wildcard.e
include file.e

include Skoda\TSIs.e
include Skoda\TSDos.e
include Skoda\TSMath.e
include Skoda\TSDebug.e




--TSEuStr_ --euphoria string routines, to use with euphoria syntax
--TSTxtLns_ --sequence with lines of text operations


--functions and procedures:
--global function findfromback(object sub,sequence s,atom p1)		
--global function TSWord_GetWords_2(sequence s,atom incNewLines,atom incAllSpaces)
--global function TSWord_FromPosAll_2(sequence s,atom startpos)
--global function TSWordGoToEdge2_2(sequence s,atom pos,atom way)
--function IsCharPartOfWord_2(atom memi, atom prev,atom next,atom hasprev,atom hasnext)
--global function TS_Str_GetQuotedString(sequence s,atom p1)
--global function TSStr_GetNewLines(sequence text)
--global function TSStr_RemoveSpacesBE(sequence s)
--global function TSSeq_ExtractNumbers(sequence s)
--global function TSSeq_InsertSequence(sequence s,object ins,atom pos)
--global function TSSeq_DeleteMember(sequence s,atom i)
--global function TSSeq_DeleteMembers(sequence s,atom p1,atom p2)
--global function matchfromback(sequence sub,sequence s,atom startpos)
--global function matchback(sequence sub,sequence s,atom startpos)	
--global function TSStr_GetMatchingWord(sequence s,sequence s1,sequence s2,atom spos,atom way)
--global function TSStr_EndOfLine(sequence s,atom spos,atom way)
--global function sequence_to_string(sequence s)
--global function findfrom(object sub,sequence s,atom startpos)
--global function matchfrom(sequence sub,sequence s,atom startpos)	
--global function TSWord_FromPosAll(sequence s,atom startpos)
--global function TSWord_GetWords(sequence s,atom incNewLines)
--global function TSStr_File_GetPureName(sequence s)
--global function TSStr_File_GetEnding(sequence path)
--global function TSString_SplitPath(sequence path)
--global function isWhiteSpace(atom c)
--global function AreJustSpaces(sequence s)
--global function FindCharInString(sequence str,atom ch,atom pos,atom way)
--global function TSWordGoToEdge2(sequence s,atom pos,atom way)
--function IsCharPartOfWord(atom memi)
--global function isdigit(atom ch)
--global function isalpha(atom ch)
--OBSOLETE global function FindStrInStr(sequence sub,sequence s,atom startpos)
--global function TSWord_FromPos(sequence s,atom startpos)
--functions and procedures.

--********************************************

---------------------------------------------------------------------------
--exactly same as TsSeq_Extract
--TESTED WORKS
--extract members from s from p1 and p2, both including
--use it if you expect string as returned value, same as mids()
---------------------------------------------------------------------------
global function mid(sequence s,
	atom p1,atom p2)

	atom len
	len=length(s)
	if len=0 then return "" end if

	if p1>p2 then return "" end if
	if p1<1 and p2<1 then return "" end if
	if p1>len and p2>len then return "" end if
	if p1<1 then return"" end if
	if p1>len then p1=len end if
	if p2<1 then p2=1 end if
	if p2>len then p2=len end if

	return s[p1..p2]
end function


---------------------------------------------------------------------------
--extarct member from s at p
--returns atom, use for characters
--if out of bounds returns 0
--use it if you expect atom as returned value
---------------------------------------------------------------------------
global function mida(sequence s,atom p)	

	atom len
	len=length(s)
	--shown("mido len",len)
	if len=0 then return 0 end if
			
	if p<1 then return 0 end if
	if p>len then return 0 end if	

	return s[p]
end function


--TESTED WORKS
--extarct member from s at p
--returns object, one member
global function mido(sequence s,atom p)	

	atom len
	len=length(s)
	--shown("mido len",len)
	if len=0 then return 0 end if
			
	if p<1 then p=1 end if
	if p>len then p=len end if	

	return s[p]
end function

--use with strings as members
--returns string
global function mids(sequence s,atom p)	

	atom len
	len=length(s)
	if len=0 then return "" end if
			
	if p<1 then p=1 end if
	if p>len then p=len end if	

	if sequence(s[p])then
		return s[p]
	else
		return ""
	end if
end function



--found equal()!
--global function same(sequence s1,sequence s2)
--	if(length(s1)=length(s2))then
--		if(s1=s2)then 
--			return 1
--		else
--			return 0
--		end if
--	end if
--end function

global function isWhiteSpace(atom c)
--'returns false if char is not whitespace otherwise true


if(c=10 or c=13)then return true
	elsif(c=9)then return true
	elsif(c=' ')then return true

	else 
	return false

end if

end function

global function AreJustSpaces(sequence s)

	atom lenn
	atom c
	
	lenn=length(s)

	for i=1 to lenn do
		c=s[i]
		if(isWhiteSpace(c)=false) then
			return false
		end if
	end for

	return true

end function

--finds space (' ' , '\n', '\t') in sting from postion
global function FindSpaceInString(sequence str,atom pos,atom way)
--DESCRIPTION:if space not found returns 0
--else returns position where char is in string
--str-string in which searching
--'ch-char searching for
--'pos-position in string where to start
--'way- 1 or -1, if 1 searches forward, if -1 backwards

atom i,cc

	i=pos

	while 1 do
		if(i>length(str))then exit end if
		if(i<1)then exit end if

		cc=str[i]
		if(isspace(cc))then return i end if

		i=i+way
	end while

return 0

end function


--finds non space character ( NOT:' ' , '\n', '\t') in sting from postion
global function FindNONSpaceInString(sequence str,atom pos,atom way)
--DESCRIPTION:if space not found returns 0
--else returns position where char is in string
--str-string in which searching
--'ch-char searching for
--'pos-position in string where to start
--'way- 1 or -1, if 1 searches forward, if -1 backwards

atom i,cc

	i=pos

	while 1 do
		if(i>length(str))then exit end if
		if(i<1)then exit end if

		cc=str[i]
		if(isspace(cc)=0)then return i end if

		i=i+way
	end while

return 0

end function


global function FindCharInString(sequence str,atom ch,atom pos,atom way)
--DESCRIPTION:if char not found returns -1
--else returns position where char is in string
--str-string in which searching
--'ch-char searching for
--'pos-position in string where to start
--'way- 1 or -1, if 1 searches forward, if -1 backwards

atom i,cc

	i=pos

	while 1 do
		if(i>length(str))then exit end if
		if(i<1)then exit end if

		cc=str[i]
		if(cc=ch)then return i end if

		i=i+way
	end while

return -1

end function

--Created: 29. marec 2000 22:18, sreda
--returns position where newline end or starts(way=1,-1)
--spos=start position where to start in s
global function TSStr_EndOfLine(sequence s,atom spos,atom way)
	atom p
	p=FindCharInString(s,'\n',spos,way)
	if p=-1 then
		if way =1 then return length(s)
		else return 1
		end if
	else
		return p
	end if	

end function


--global function FindStringInString(sequence str,sequence substr,atom pos,atom way)
--DESCRIPTION:if substring not found returns -1
--else returns position where substr is in string
--str-string in which searching
--'substr-sub string searching for
--'pos-position in string where to start
--'way- 1 or -1, if 1 searches forward, if -1 backwards

--	atom lenstr,lensubstr,i
--	lenstr=length(str)
--	lensubstr=length(substr)
--	i=pos

--	while i<=lenstr and i>0 do
		
--		if(equal(substr,str[i...i+lensubstr]))
--			return i
--		end if
--		
--		i+=1
--	end while
--
--	return -1
--
--end function


--global function isalpha(atom ch)
--23.8.99 21:48:20 - created
--RETURNS: 0 if not alpha
--				1 if lowercase
--				2 if UPPERCASE
--alphas: BIG (UPPERCASE A-Z): 65-90 - both including
--alphas: small (lowercase a-z): 97-122 - both including
	
--	if(ch='')then return false end if

	--if UPPERCASE
--	if(ch<=90 and ch>=65)then return true end if

	--if lowercase
--	if(ch<=122 and ch>=97)then return true end if

--	return false
	

--end function

--global function isdigit(atom ch)
--true if ch is digit, false otherwise
--digits:48-57 - both including
	
--	if(ch="")then isdigit=false:exit function
		
--	if(ch<=57 and ch>=48)then
--		return true
--	else
--		return false
--	end if
--end function


function IsCharPartOfWord(atom memi)
--returns true if char is part of word
--alphas and digits and some other special chars
--are part of word, these for ex. are not:
--!@#$%
	sequence PartOfWord
	PartOfWord=".-_"

	if(isalpha(memi)=0 and  
	isdigit(memi)=false and 
	FindCharInString(PartOfWord,memi,1,1)=-1)then
		return false
	else 
		return true
	end if
end function


global function TSWordGoToEdge2(sequence s,atom pos,atom way)
--this one is used by different sub, previous with diff.
--maybe, so leave both functions
--this one goes to the last or firts character of word
--it's important that this char is within word!
--previuous sub went sometimes 1 char over word,
--sometimes it stayed within word,
--so from now on use this function, but leave previous
--cause it's maybe used by some other sub
--{
	atom lens,i,IscPart,prevIscPart,c
	--sequence c

	prevIscPart=false

	lens=length(s)
	i=pos

	c=s[i]
	--'msgbox("FIRST CHAR:"+c)

	while 1 do
		if(i<1 or i>lens)then exit end if
		c=s[i]
		

		IscPart=IsCharPartOfWord(c)
		
		--'if not part of word then break, got
		--'to edge
		if(IscPart=false)then		
			--'if prev char is part of word go backone
			--'to stay within word
			if(prevIscPart=true)then i=i-way end if

			--'msgbox("BREAKIN WITH:"+c)
			exit
		end if
		
		prevIscPart=IscPart
		i=i+way
	end while

	return i

--}
end function

--same as matchfrom
--OBSOLETE, replaced by matchfrom
global function FindStrInStr(sequence sub,sequence s,atom startpos)
--returns 0 if not found
--i goes only forward

atom retpos

retpos=match(sub,s[startpos..length(s)])

if retpos=0 then return 0 end if

retpos=startpos+retpos
return retpos

end function


global function TSWord_FromPos(sequence s,atom startpos)
--gets word, excludes spaces
--GETTING WORD FORWARD:
--returns:{word,position,ifgotword}
--word=word which has character at startpos
--position=position in s of 1. word's character,
--	CAUTION:must be 1 character of word
--ifgotword=1 if word was found, 0 if not foud
	
    atom i,i2,lens,doexit
    sequence word,ret
    doexit=false

	ret=repeat(0,3)
    
    i=startpos
   lens=length(s)
  
     --go word by word
    while i<lens do
  
        i2=TSWordGoToEdge2(s,i,1)
        
        if(i2>lens)then i2=lens doexit=true end if
        word=s[i..i2]        
            
        --handle nonspace word we got
        if(AreJustSpaces(word)=false) then
			ret[1]=word
			ret[2]=i2+1			
			ret[3]=1
			return ret
        end if
            
        if doexit=true then exit end if
        
        i=i2+1                

    end while
--GETTING WORD FORWARD.
	
	return ret -- none word got
end function

global function TSWord_FromPosAll(sequence s,atom startpos)
--gets word, includes all words
--GETTING WORD FORWARD:
--returns:{word,position,ifgotword}
--word=word which has character at startpos
--position=position in s of 1. word's character,
--	CAUTION:must be FIRST character of word
--ifgotword=1 if word was found, 0 if not foud
	
    atom i,i2,lens,doexit
    sequence word,ret
    doexit=false

	ret=repeat(0,3)
    
    i=startpos
   lens=length(s)
  
     --go word by word
    while i<lens do
  
        i2=TSWordGoToEdge2(s,i,1)
        
        if(i2>lens)then i2=lens doexit=true end if
        word=s[i..i2]        
		                    
			ret[1]=word
			ret[2]=i2+1			
			ret[3]=1
		return ret   
            
        if doexit=true then exit end if
        
        i=i2+1                

    end while
--GETTING WORD FORWARD.
	
	return ret -- none word got
end function


--from c:\\arj.exe retunrs arj.exe
--or from arj.exe retunrs arj.exe
global function TSStr_GetFilename(sequence path)
	atom p
	p=FindCharInString(path,'\\',length(path),-1)
	if p=-1 then
		return path
	else
		return(path[p+1..length(path)])	
	end if
end function


--from c:\\euphoria\\arj.exe returns c:\\euphoria
--if there is no path returns ""
global function TSStr_File_GetDirectory(sequence path)
	atom p
	p=FindCharInString(path,'\\',length(path),-1)
	if p=-1 then
		return ""
	else
		return(mid(path,1,p-1))
	end if
end function

--http://www.ntua.gr/electronics
--splits into 
--1.http:
--2.www.ntua.gr
--3.electronics
--and saves it in returned sequence
--http://www.ntua.gr/electronics/chipdir/abc/m.htm#monitor_and_debugger
--Created: 24. marec 2000 20:53, petek
global function TSString_SplitPath(sequence path)
	sequence ret
	atom prev,i,endpath
	prev=1
	ret={}
	i=1
	endpath=0

	while 1 do
		--textoutwait("\n%s",path[i])
		if(i>=length(path))then
			if(prev<i)then
				ret=append(ret,path[prev..i])
			end if
			exit
		end if

		if(path[i]='\\' or path[i]='/')then
			if(prev<i)then
				ret=append(ret,path[prev..i-1])
			end if
			prev=i+1
		end if
		
		i+=1		
	end while

	return ret
end function


---------------------------------------------------------------------------
--from file.txt returns txt
---------------------------------------------------------------------------
global function TSStr_File_GetExt(sequence path)
	atom p	
	p=FindCharInString(path,'.',length(path),-1)
	if p=-1 then return "" end if
	return(path[p+1..length(path)])
end function


---------------------------------------------------------------------------
--same as TSStr_File_GetExt
---------------------------------------------------------------------------
global function TSStr_File_GetEnding(sequence path)
	atom p	
	p=FindCharInString(path,'.',length(path),-1)
	if p=-1 then return "" end if
	return(path[p+1..length(path)])
end function


--returns name from ...name.end
global function TSStr_File_GetPureName(sequence path)
	atom p,p1
	p=FindCharInString(path,'.',length(path),-1)	
	p1=FindCharInString(path,'\\',length(path),-1)
	if(p1<1)then p1=1 end if
	if(p<1)then p=length(path) end if
	return(path[p1+1..p-1])	
end function

global function TSStr_File_RemoveEnding(sequence path)
	atom p
	p=FindCharInString(path,'.',length(path),-1)
	if p=-1 then
		return path
	else
		return(path[1..p-1])
	end if	
end function

--Created: 26. marec 2000 16:05, nedelja
--saves words in sequence
--returns sequences where words are saved
--excludes spaces
--except if incNewLines=1, then includes newlines ('\n')
global function TSWord_GetWords(sequence s,atom incNewLines)	
	sequence ret	,reet
	ret=repeat(0,3)
	ret[2]=1
	reet={}

	while 1 do
		ret=TSWord_FromPosAll(s,ret[2])
		if(ret[3]=0)then exit end if
		
		--if 1.word isnt spaces or 
		--2.word is spaces and user defined switch
		--to include newlines and this white space
		--is newline, 
		--then include word in results
		if(AreJustSpaces(ret[1])=0 or (AreJustSpaces(ret[1])=1 and incNewLines=1 and ret[1][1]='\n'))then
			reet=append(reet,ret[1])
		end if
	end while

	return reet

end function

--Created: 26. marec 2000 19:36, nedelja
--returns 0 if not found or position where sub is in s
--use it with general sequences
global function findfrom(object sub,sequence s,atom startpos)	
	atom i
	
	i=find(sub,s[startpos..length(s)])
	if i=0 then return 0 end if
	
	return(i+startpos)
end function

--Created: 26. marec 2000 19:36, nedelja
--returns 0 if not found or position where sub is in s
--use it with strings(sequences which dont have sequences
-- but just atoms?)
global function matchfrom(sequence sub,sequence s,atom startpos)	
	atom i

	i=match(sub,s[startpos..length(s)])
	if i=0 then return 0 end if
	
	return (i+startpos-1)
end function

--RETURNS 0 if not found or *start* position where sub is in s
--goes from backwards
--use with strings
global function matchfromback(sequence sub,sequence s,atom startpos)
	atom sublen,i,lens
	sequence ret

	ret=repeat(0,2)
	sublen=length(sub)
	lens=length(s)

	--textoutwait("\n%s%d%s%d",{"startpos=",startpos,", sublen=",sublen})

	i=startpos
	if i>lens then
		i=lens
	end if

	while 1 do		
		if i-sublen<1 then return 0 end if		
--		shown("i-sublen+1",i-sublen+1)
--		shown("i",i)
--		shown("sublen",sublen)
--		shown("length(s)",length(s))		
		if equal(s[i-sublen+1..i],sub)then
			return i
		end if	
		i-=1
		if i<1 then exit end if
	end while

	return 0
end function


--Warning untested code:

 global function sequence_to_string(sequence s)
     sequence rs
     rs={}
     for i=1 to length(s) do
         if atom(s[i]) then
             rs&=s[i]
         else
             rs&=sequence_to_string(s[i])
         end if
     end for
     return rs
 end function


--"f1(f2(a2,a3,f3(f4())),fa1)"
--way: must be 1 or -1
--spos must be before s1, s2 cant be before s1
--RETURNS: position of start of the word in s, 0 if not found
--searches for s2
global function TSStr_GetMatchingWord(sequence s,
	sequence s1,sequence s2,atom spos,atom way)

	atom i,s1len,s2len,n1,n2,s1way,s2way,slen
	sequence s1m,s2m

	i=spos
	s1len=length(s1)
	s2len=length(s2)
	s1way=s1len*way
	s2way=s2len*way
	slen=length(s)
	n1=0 --number of s1 words
	n2=0 --number of s2 words	

NewDosTextColor()
	while 1 do
		--get words of length s1 and s2:
		if i+s1way-way>slen or i+s1way<1 then exit end if
		shown("i+s1way-way",i+s1way-way)
		shown("i",i)
		shown("slen",slen)		
		s1m=s[Min(i,i+s1way-way)..Max(i,i+s1way-way)]		
		show("s1m",s1m)
		if i+s2way-1>slen or i+s2way<1 then exit end if				
		s2m=s[Min(i,i+s2way-way)..Max(i,i+s2way-way)]				
		show("s2m",s2m)
		--textout("\n%s%d%s%d%s%d%s%d",{"s1way=",s1way,", s2way=",s2way,", i=",i,", i+s2way=",i+s2way})
		--textout("\n%s%d%s%d",{"n1=",n1,", n2=",n2})
		--textoutwait("\n%s%s%s%s",{"s1m=",s1m,", s2m=",s2m})
		--get words of length s1 and s2.

		--increase n1 if equal
		if equal(s1m,s1)then 
			n1+=1
		end if

		--increase n2 if equal
		--and finish if n2=n1
		if equal(s2m,s2)then 
			n2+=1
			
			--ERROR
			--if n1=0 then textoutswait("TSStr_GetMatchingWord error1: s2 found before s1, s1num=0") abort(0) end if
			--get over error man
			if n1=0 then n1=1 end if
			
			--if n1=n2 then found matchin word!
			if(n1=n2) then return i end if
		end if

		i+=way	
		if i>slen or i<1 then exit end if	
	end while

	--not found
	return 0
end function


----{"one","two"{"2one",{"3one","3two"},"2two"},"three"}
--(((hr) >> 16) & 0x1fff)
--("one","two"("2one",("4one","4two")("3one","3two"),"2two"),"three")
--returns {("4one","4two"),startpos,endpos}
--s1="(","{",...
--s2=")","}",...
--gets string that is between s1 and s2 and is most nested
global function TSStr_Match_MostNested(sequence s,sequence s1,sequence s2)
	sequence ret
	atom p2,p1

	ret=repeat(0,3)

	p2=match(s2,s)-length(s2)

	p1=matchfromback(s1,s,p2)+length(s1)

	if p2=0 or p1=0 then return {"",0,0} end if

	ret[3]=p2
	ret[2]=p1
	ret[1]=s[p1..p2]

	return ret
end function

--deletes members of s between p1(including) and p2(including)
global function TSSeq_DeleteMembers(sequence s,atom p1,atom p2)
	return(s[1..p1-1] & s[p2+1..length(s)])
end function

--deletes one member of seuence
global function TSSeq_DeleteMember(sequence s,atom i)
	return(s[1..i-1] & s[i+1..length(s)])
end function

--USE TsSeq_Insert!
--RETURNS: new sequence
--insert sequence intosequence at position
--pos=startposition
--inserted sequence is at position 'pos'
global function TSSeq_InsertSequence(sequence s,object ins,atom pos)
	return s[1..pos-1] & ins & s[pos..length(s)]
end function



--RETURNS all numbers extracted from 's'
--'s' must contain strings
global function TSSeq_ExtractNumbers(sequence s)
	sequence r
	r={}

	for i=1 to length(s) do		
		if IsWordDigit(s[i])=true then
			r=append(r,s[i])
			--tw("%s%s",{s[i]," is digit"})
		else
			--tw("%s%s",{s[i]," is NOT digit"})
		end if

		
	end for

	--tw("%s%d",{"length(r)=",length(r)})

	return r
end function


--it works
--Created: 9. april 2000 00:20, nedelja
--removes spaces form begining and end of string
global function TSStr_RemoveSpacesBE(sequence s)
	atom i,p1,p2
	i=1

	while isspace(s[i])=true and i<length(s) do		
		i+=1
	end while
	p1=i

	i=length(s)

	while isspace(s[i])=true and i>1 do
		i-=1		
	end while
	p2=i

--	dostextwait("%s%d%s%d",{
--	"p1=",p1,
--	"\np2=",p2
--	})

	if(p1>p2) then return "" end if

	return s[p1..p2]

end function


--returns sequence which holds indices where newline ('\n') characters in 's' are
global function TSStr_GetNewLines(sequence s)
	sequence r

	r={}

	for i=1 to length(s) do
		if s[i]='\n' then
			r=append(r,i)
		end if
	end for

	return r
end function


--returns sequence which holds indices where newline ('\n') characters in 's' are, plus 1 at start and length(s) at end
global function TSStr_GetNewLines_Perfect(sequence s)
	sequence r

	r={1}

	for i=1 to length(s) do
		if s[i]='\n' then
			r=append(r,i)
		end if
	end for

	r=append(r,length(s))

	return r
end function



--returns {succes,string,endpos}
--returns euphoria's string " words "
--endpos = position of last "
--p1 must be behind firts "
global function TS_Str_GetQuotedString(sequence s,atom p1)

	if p1<1 or p1>length(s) then return{0} end if
	
	for i=p1 to length(s) do
		--shown("iii",i)
		if s[i]='\"' then
			if i>1 then
				if s[i-1]!=92 then --mustnt be \"
					return {1,s[p1..i-1],i}
				end if
			else
				return {1,s[p1..i-1],i}
			end if
		end if
	end for

	return {0}
end function



--returns {succes,string,start}
--returns euphoria's string " words "
--start= position of first "
--p1 must be before last "
--goes back
global function TS_Str_GetQuotedStringBack(sequence s,atom p1)

	if p1<1 or p1>length(s) then return{0} end if
	
	for i=p1 to 1 by -1 do
		--shown("iii",i)
		if s[i]='\"' then
			if i>1 then
				if s[i-1]!=92 then --mustnt be \"
					return {1,s[i+1..p1],i}
				end if
			else
				return {1,s[i+1..p1],i}
			end if
		end if
	end for

	return {0}
end function




--*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

function IsCharPartOfWord_2(atom memi, atom prev,atom next,
	atom hasprev,atom hasnext)
--
--returns true if char is part of word
--alphas and digits and some other special chars
--are part of word, these for ex. are not:
--!@#$%	

	sequence PartOfWord
	PartOfWord="._"
	--TODO fix - character

	--showw("character is",memi)

		if (memi='.')then			
			if hasprev and hasnext then
				--if c.c or _.c or c._
				--"main.shit"
				if isdigit(prev) and isdigit(next)then
					return true
				else
					return false
				end if
--				if (isalpha(prev) or find(prev,"_") )and 
--					(isalpha(next) or find(next,"_") ) then
--					return false
--				else --previous and next are digits
--					--"1.23"
--					return true
--				end if
			end if
		
		-- "-1" is one word, "-word" are 2 words
		elsif memi='-' then
			if hasnext then
--				show("prev",prev)
--				show("memi",memi)
--				showw("next",next)
				if isdigit(next) then
					return true
				else
					return false
				end if
			end if

		else
			if(isalpha(memi)=0 and  
				isdigit(memi)=false and 
				FindCharInString(PartOfWord,memi,1,1)=-1)then
					return false
			else 
				return true
			end if
		end if

		return false
end function


global function TSWordGoToEdge2_2(sequence s,atom pos,atom way)
--DIFFERENCE from TSWordGoToEdge2:
	--string is one word (" words ")
	--1.23 is one word, main.shit are THREE words
--RETURNS index of last char of word in 's'
--this one is used by different sub, previous with diff.
--maybe, so leave both functions
--this one goes to the last or firts character of word
--it's important that this char is within word!
--previuous sub went sometimes 1 char over word,
--sometimes it stayed within word,
--so from now on use this function, but leave previous
--cause it's maybe used by some other sub
--{

	atom lens,i,IscPart,prevIscPart,c
	--sequence c
	atom hasprev,hasnext,pprev,pnext,nm
	sequence sret

	prevIscPart=false

	lens=length(s)
	i=pos

	c=s[i]
			

	while 1 do
		if(i<1 or i>lens)then exit end if
		c=s[i]


		--got to matching "
		if c='"' then
			sret=TS_Str_GetQuotedString(s,i+1)
			if sret[1]=1 then
				return sret[3]			
			end if
		end if

		if i<=1 then hasprev=0
		else hasprev=1
		end if

		if i>=length(s)then hasnext=0
		else hasnext=1 
		end if

		if (hasprev=0) then pprev=0 else pprev=s[i-1] end if
		if (hasnext=0) then pnext=0 else pnext=s[i+1] end if
		IscPart=IsCharPartOfWord_2(c,pprev,pnext,
			hasprev,hasnext)

		
		--'if not part of word then break, got
		--'to edge
		if(IscPart=false)then		
			--'if prev char is part of word go backone
			--'to stay within word
			if(prevIscPart=true)then i=i-way end if			
			exit
		end if
		
		prevIscPart=IscPart
		i=i+way
	end while

	return i

end function



global function TSWord_FromPosAll_2(sequence s,atom startpos)
--gets word, includes all words
--GETTING WORD FORWARD:
--returns:{word,position,ifgotword}
--word=word which has character at startpos
--position=position in s of 1. word's character,
--	CAUTION:must be FIRST character of word
--ifgotword=1 if word was found, 0 if not foud
--DIFFERENCE from TSWord_FromPosAll:
	--string is one word (" words ")
	--1.23 is one word, main.shit are THREE words
	
    atom i,i2,lens,doexit
    sequence word,ret
    doexit=false

	ret=repeat(0,3)
    
    i=startpos
   lens=length(s)
  
     --go word by word
    while i<lens do
  
        i2=TSWordGoToEdge2_2(s,i,1)
        
        if(i2>lens)then i2=lens doexit=true end if
        word=s[i..i2]        
		                    
			ret[1]=word
			ret[2]=i2+1			
			ret[3]=1
		return ret   
            
        if doexit=true then exit end if
        
        i=i2+1                

    end while
--GETTING WORD FORWARD.
	
	return ret -- none word got
end function

--saves words in sequence
--returns sequences where words are saved
--excludes spaces
--except if incNewLines=1, then includes newlines ('\n')
--DIFFERENCE from TSWord_GetWords:
	--string is one word (" words ")
	--1.23 is one word, main.shit are THREE words
--incAllSpaces - if to include all spaces in result, each space is one word
	--if this is 1 then it doesnt matter what 'incNewLines' arg is
global function TSWord_GetWords_2(sequence s,atom incNewLines,atom incAllSpaces)
	sequence ret	,reet
	ret=repeat(0,3)
	ret[2]=1
	reet={}

	while 1 do
		ret=TSWord_FromPosAll_2(s,ret[2])
		if(ret[3]=0)then exit end if
		
		--includes all spaces
		if incAllSpaces then
			reet=append(reet,ret[1])

		--if 1.word isnt spaces or 
		--2.word is spaces and user defined switch
		--to include newlines and this white space
		--is newline, 
		--then include word in results
		else
			if(AreJustSpaces(ret[1])=0 or 
				(AreJustSpaces(ret[1])=1 and incNewLines=1 and ret[1][1]='\n'))then
				reet=append(reet,ret[1])
			end if
		end if
	end while

	return reet

end function

global function TSWordGoToEdge2_Eu(sequence s,atom pos,atom way)
--DIFFERENCE from TSWordGoToEdge2:
	--string is one word (" words ")
	--1.23 is one word, main.shit are THREE words
--CAUTON: pos must be first character of word
--RETURNS index of last char of word in 's'
--this one is used by different sub, previous with diff.
--maybe, so leave both functions
--this one goes to the last or firts character of word
--it's important that this char is WITHIN word!
--previuous sub went sometimes 1 char over word,
--sometimes it stayed within word,
--so from now on use this function, but leave previous
--cause it's maybe used by some other sub
--{

	atom lens,i,IscPart,prevIscPart,c
	--sequence c
	atom hasprev,hasnext,pprev,pnext,nm,p10
	sequence sret

	prevIscPart=false

	lens=length(s)
	i=pos

	c=s[i]

	if i<=1 then hasprev=0
	else hasprev=1
	end if

	if i>=length(s)then hasnext=0
	else hasnext=1 
	end if

	
	--got to matching "
		if s[pos]='"' then
			sret=TS_Str_GetQuotedString(s,i+1)
			if sret[1]=1 then
				return sret[3]			
			end if
		elsif s[pos]='-' then
			if hasnext then
				if s[pos+1]='-' then					
					p10=matchfrom("\n",s,i)
					if p10=0 then
						p10=length(s)
					else
						p10-=2
					end if

					return p10
				end if
			end if
		end if		

			

	while 1 do
		if(i<1 or i>lens)then exit end if
		c=s[i]

		if i<=1 then hasprev=0
		else hasprev=1
		end if

		if i>=length(s)then hasnext=0
		else hasnext=1 
		end if
		
		if (hasprev=0) then pprev=0 else pprev=s[i-1] end if
		if (hasnext=0) then pnext=0 else pnext=s[i+1] end if
		IscPart=IsCharPartOfWord_2(c,pprev,pnext,
			hasprev,hasnext)

--if c='.' then
--		show("IscPart",IscPart)
--		show("three",{pprev,c,pnext})
--		show("hasprev",hasprev)
--		show("hasnext",hasnext)
--		show("pprev",pprev)
--		show("pnext",pnext)
--end if

		
		--'if not part of word then break, got
		--'to edge
		if(IscPart=false)then		
			--'if prev char is part of word go backone
			--'to stay within word
			if(prevIscPart=true)then i=i-way end if			
			exit
		end if
		
		prevIscPart=IscPart
		i=i+way
	end while

	return i

end function





global function IsCharPartOfWord_Eu1(atom memi, atom prev,atom next,
	atom hasprev,atom hasnext)
--
--returns true if char is part of word
--alphas and digits and some other special chars
--are part of word, these for ex. are not:
--!@#$%	

	sequence PartOfWord
	PartOfWord="._"
	--TODO fix - character

	--showw("character is",memi)

		if (memi='.')then			
			if hasprev and hasnext then
				--prev and next digits
				if isdigit(prev) and isdigit(next) then
					return true
				else
					return false
				end if			
			end if
		
		-- "-1" is one word, "-word" are 2 words
		--
		elsif memi='-' then
			if hasnext then
				if isdigit(next) then
					if hasprev then					
						if prev='-' then --if eu comment
							return false
						else
							return true
						end if
					else
						return true
					end if
				else
					return false
				end if
			end if

		else
			if(isalpha(memi)=0 and  
				isdigit(memi)=false and 
				find(memi,PartOfWord)=0)then
					return false
			else 
				return true
			end if
		end if

		return false
end function

--Created: 20. junij 2000 17:24, torek
--WORKS
global function TSWordGoToEdge_Eu2(sequence s,atom pos,atom way)
--DIFFERENCE from TSWordGoToEdge2_Eu:
	--string is NOT one word (" words ")
	--1.23 is one word, main.shit are THREE words
	--comment are many words, not one
--CAUTION: pos must be first character of word
--RETURNS index of last char of word in 's'
--this one is used by different sub, previous with diff.
--maybe, so leave both functions
--this one goes to the last or firts character of word
--it's important that this char is WITHIN word!
--previuous sub went sometimes 1 char over word,
--sometimes it stayed within word,
--so from now on use this function, but leave previous
--cause it's maybe used by some other sub
--{

	atom lens,i,IscPart,prevIscPart,c
	--sequence c
	atom hasprev,hasnext,pprev,pnext,nm,p10
	sequence sret

	prevIscPart=false

	lens=length(s)
	if lens<=0 then
		return 0	
	end if
	if pos>lens then
		return lens+1
	elsif pos<=0 then
		return 0
	end if
	i=pos

	c=s[i]

	if i<=1 then hasprev=0
	else hasprev=1
	end if

	if i>=length(s)then hasnext=0
	else hasnext=1 
	end if

	
	--got to matching "
		if s[pos]='"' then
		    if way=-1 then
				sret=TS_Str_GetQuotedStringBack(s,i-1)
			else
				sret=TS_Str_GetQuotedString(s,i+1)
			end if
			if sret[1]=1 then
				return sret[3]			
			end if
		--BACKWARDS!!!not working here
		elsif s[pos]='-' then
			if hasnext then
				if s[pos+1]='-' then					
					p10=matchfrom("\n",s,i)
					if p10=0 then
						p10=length(s)
					else
						p10-=2
					end if

					return p10+1
				end if
			end if
		end if		

			

	while 1 do
		if(i<1) then return 1 end if
		if(i>lens)then return lens end if
		c=s[i]

		if i<=1 then hasprev=0
		else hasprev=1
		end if

		if i>=length(s)then hasnext=0
		else hasnext=1 
		end if
		
		if (hasprev=0) then pprev=0 else pprev=s[i-1] end if
		if (hasnext=0) then pnext=0 else pnext=s[i+1] end if
		IscPart=IsCharPartOfWord_Eu1(c,pprev,pnext,
			hasprev,hasnext)
		
		--'if not part of word then break, got
		--'to edge
		if(IscPart=false)then		
			--'if prev char is part of word go backone
			--'to stay within word
			if(prevIscPart=true)then i=i-way end if			
			exit
		end if
		
		prevIscPart=IscPart
		i=i+way
	end while

	return i

end function



--Created: 16. junij 2000 13:47, petek
global function TSWordGoToEdge_Eu1(sequence s,atom pos,atom way)
--DIFFERENCE from TSWordGoToEdge2_Eu:
	--string is NOT one word (" words ")
	--1.23 is one word, main.shit are THREE words
	--comment are many words, not one
--CAUTION: pos must be first character of word
--RETURNS index of last char of word in 's'
--this one is used by different sub, previous with diff.
--maybe, so leave both functions
--this one goes to the last or firts character of word
--it's important that this char is WITHIN word!
--previuous sub went sometimes 1 char over word,
--sometimes it stayed within word,
--so from now on use this function, but leave previous
--cause it's maybe used by some other sub
--{

	atom lens,i,IscPart,prevIscPart,c
	--sequence c
	atom hasprev,hasnext,pprev,pnext,nm,p10
	sequence sret

	prevIscPart=false

	lens=length(s)
	i=pos

--	c=s[i]

	if i<=1 then hasprev=0
	else hasprev=1
	end if

	if i>=length(s)then hasnext=0
	else hasnext=1 
	end if

	
	----got to matching "
--		if s[pos]='"' then
--			sret=TS_Str_GetQuotedString(s,i+1)
--			if sret[1]=1 then
--				return sret[3]			
--			end if
--		elsif s[pos]='-' then
--			if hasnext then
--				if s[pos+1]='-' then					
--					p10=matchfrom("\n",s,i)
--					if p10=0 then
--						p10=length(s)
--					else
--						p10-=2
--					end if
--
--					return p10
--				end if
--			end if
--		end if		
--
			

	while 1 do
		if(i<1 or i>lens)then exit end if
		c=s[i]

		if i<=1 then hasprev=0
		else hasprev=1
		end if

		if i>=length(s)then hasnext=0
		else hasnext=1 
		end if
		
		if (hasprev=0) then pprev=0 else pprev=s[i-1] end if
		if (hasnext=0) then pnext=0 else pnext=s[i+1] end if
		IscPart=IsCharPartOfWord_Eu1(c,pprev,pnext,
			hasprev,hasnext)
		
		--'if not part of word then break, got
		--'to edge
		if(IscPart=false)then		
			--'if prev char is part of word go backone
			--'to stay within word
			if(prevIscPart=true)then i=i-way end if			
			exit
		end if
		
		prevIscPart=IscPart
		i=i+way
	end while

	return i

end function



global function TSWord_FromPosAll_Eu(sequence s,atom startpos)
--gets word, includes all words
--GETTING WORD FORWARD:
--returns:{word,position,ifgotword}
--word=word which has character at startpos
--position=position in s of 1. word's character,
--	CAUTION:must be FIRST character of word
--ifgotword=1 if word was found, 0 if not foud
--DIFFERENCE from TSWord_FromPosAll:
	--string is one word (" words ")
	--1.23 is one word, main.shit are THREE words
	
    atom i,i2,lens,doexit
    sequence word,ret
    doexit=false

	ret=repeat(0,3)
    
    i=startpos
   lens=length(s)
  
     --go word by word
    while i<=lens do
	
        i2=TSWordGoToEdge2_Eu(s,i,1)

        
        if(i2>lens)then i2=lens doexit=true end if
        word=s[i..i2]

--		show("i",i)
--		show("i2",i2)
--		showw("word",word)
		                    
			ret[1]=word
			ret[2]=i2+1			
			ret[3]=1
		return ret   
            
        if doexit=true then exit end if
        
        i=i2+1                

    end while
--GETTING WORD FORWARD.
	
	return ret -- none word got
end function

--saves words in sequence
--returns sequences where words are saved
--excludes spaces
--except if incNewLines=1, then includes newlines ('\n')
--DIFFERENCE from TSWord_GetWords:
	--string is one word (" words ")
	--1.23 is one word, main.shit are THREE words
--incAllSpaces - if to include all spaces in result, each space is one word
	--if this is 1 then it doesnt matter what 'incNewLines' arg is
--DIFFERENCE from TSWord_GetWords_2: 
	-- '--words'  is one word, ie. euphoria comment is one word
global function TSWord_GetWords_Eu(sequence s,atom incNewLines,atom incAllSpaces)
	sequence ret	,reet
	ret=repeat(0,3)
	ret[2]=1
	reet={}
	

	while 1 do
	
		ret=TSWord_FromPosAll_Eu(s,ret[2])
		
		if(ret[3]=0)then 
			exit
			--reet=append(reet,)
		end if		
		
		--includes all spaces
		if incAllSpaces then
			reet=append(reet,ret[1])

		--if 1.word isnt spaces or 
		--2.word is spaces and user defined switch
		--to include newlines and this white space
		--is newline, 
		--then include word in results
		else
			if(AreJustSpaces(ret[1])=0 or 
				(AreJustSpaces(ret[1])=1 and incNewLines=1 and ret[1][1]='\n'))then
				reet=append(reet,ret[1])
			end if
		end if
	end while

	return reet

end function


--*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

--better than findfrom
--returns index or 0 if unsuccess
global function findfrom2(object sub,sequence s,atom p1)
	
	for i=p1 to length(s) do
		if equal(sub,s[i]) then
			return i
		end if
	end for

	return 0
end function


--searches for object in sequence that matches 'sub'
--backwarda from position 'p1'
--returns: index of 'sub' in 's'
--returns index or 0 if unsuccess
global function findfromback(object sub,sequence s,atom p1)		
	
	while p1>0 do
		if equal(sub,s[p1]) then
			return p1
		end if
		p1-=1
	end while

	return 0
end function


--global function TSEuStr_


--Created: 26. april 2000 19:48, sreda
--"f1(f2(a2,a3,f3(f4())),fa1)"
--way: must be 1 or -1
--spos must be before s1, s2 cant be before s1
--RETURNS: index of found word or 0 if unsuccess
--searches for s2
--DIFFERENCE from 'TSStr_GetMatchingWord':
	--s here can also have words in it
global function TSSeq_GetMatchingWord(sequence s,object o1,object o2,atom spos)
	atom i,n1,n2

	i=spos
	n1=0
	n2=0
	
	while 1 do
		if i>length(s) then return 0 end if
		
		if equal(s[i],o1)then
			n1+=1		
			if n1=n2 then return i end if
		end if

		if equal(s[i],o2)then
			n2+=1		
			if n1=n2 then return i end if
		end if

		i+=1
	end while

	return 0

end function

--Created: 29. april 2000 15:56, sobota
--translates
--atom /*comment*/ a
--atom b //comment
--
--to:
--
--atom  a
--atom b 
--
--
global function RemoveCComments(sequence s)
	atom i,nl
	sequence ret

	ret=""
	i=1

	while 1 do
		if i>length(s)then exit end if

		if i+1<=length(s) then
			--showw("s[i..i+1]",s[i..i+1])
			
			--//
			if equal(s[i..i+1],"//") then
				i=matchfrom("\n",s,i)				
				if i=0 then
					return ret
				end if
				i-=1
				--show("leavin oout till",s[i-5..i])
				--showw("i",i)				
			--/**/
			elsif equal(s[i..i+1],"/*")then
				i=matchfrom("*/",s,i)
				if i=0 then
					return ret
				end if				
				--show("leavin oout till",s[i-5..i])
			else
				ret&=s[i]
			end if

		else
			exit
		end if		

		i+=1
	end while

	return ret

end function

--removes comments from text
--C: C++ comments (//,/**/)
--E: Euphoria comments (--)
--B: Batch comments (;)
global function RemoveCEBComments(sequence s)
	atom i,nl
	sequence ret

	ret=""
	i=1

	while 1 do
		if i>length(s)then exit end if

		if s[i]=';' then
			i=matchfrom("\n",s,i)
			if i=0 then
				return ret
			end if
			i-=1
			--show(";;;;leavin oout till",s[i-5..i])
			--showw("i",i)
		else		

		if i+1<=length(s) then
			--showw("s[i..i+1]",s[i..i+1])
			
			--//
			if equal(s[i..i+1],"//") or equal(s[i..i+1],"--") then
				i=matchfrom("\n",s,i)				
				if i=0 then
					return ret
				end if
				i-=1
				--show("leavin oout till",s[i-5..i])
				--showw("i",i)				
			--/**/
			elsif equal(s[i..i+1],"/*")then
				i=matchfrom("*/",s,i)
				if i=0 then
					return ret
				end if								
				--show("leavin oout till",s[i-5..i])
			else
				ret&=s[i]
			end if

		else
			exit
		end if	
		
		end if	

		i+=1
	end while

	return ret

end function



--so far you can only use atoms to use a delimiters to split strings by.
--
--use the function like this:
--
--sequence s,words
--
--s = "hello!world"
--
--words = split('!',s)
global function split(atom char,  sequence string)
  sequence ret
  integer c
  ret = {{}}
  c = 1
  for i = 1 to length(string) do
    if string[i] = char then
      ret = append(ret,{})
      c = length(ret)
    else
      ret[c] &= string[i]
    end if
  end for
  return ret
end function

--splits text to lines of text
--if text is "a" return {{a}}
--if text is "a\n"b" return {{a},{b}}
--if text is "" return {{}}
global function split_to_lines(sequence string)  
  sequence ret
  integer c
  ret = {{}}
  c = 1
  for i = 1 to length(string) do
    if string[i] = 10 then
      ret = append(ret,{})
      c = length(ret)
    elsif string[i] != 13 then
      ret[c] &= string[i]
    end if
  end for
  return ret
end function


--eliminates members from sequence, including p1 and p2
global function TsSeq_Eliminate(sequence s,atom p1,atom p2)
	atom len
	len=length(s)

	if p1>p2+1 then
		printf(1,"\n%s",{"Error in function TsSeq_Eliminate: p1>p2"})
	end if

	p1-=1
	p2+=1

	if p1<0 then p1=0 end if
	if p1>len then p1=len end if
	if p2<1 then p2=1 end if
	if p2>len+1 then p2=len+1 end if

	--shown("p1",p1)
	--shown("p2",p2)

	return s[1..p1] & s[p2..len]
end function


--TESTED WORKS
--inserts ns in s after character with index p
--p is any number, if out of bounds, then appends or prepends ins to s
global function TsSeq_Insert(sequence s,object ns,
	atom p)
	
	atom len 
	len=length(s)
	if p>len then
		return s & ns
	elsif p<1 then
		return ns & s
	end if
	

	return s[1..p] & ns & s[p+1..len]
end function



--TESTED WORKS
--extarct members from s from p1 and p2, both including
global function TsSeq_Extract(sequence s,
	atom p1,atom p2)

	atom len
	len=length(s)

	if p1>p2 then return {} end if
	if p1<1 and p2<1 then return {} end if
	if p1>len and p2>len then return {} end if
	if p1<1 then p1=1 end if
	if p1>len then p1=len end if
	if p2<1 then p2=1 end if
	if p2>len then p2=len end if

	return s[p1..p2]
end function



--TESTED WORKS
--deletes last member from sequence
global function TsSeq_DeleteLast(sequence s)
	return s[1..length(s)-1]
end function


--TESTED WORKS
--returns string that is only to position p of s, including p
--arg p: how many characters from right wil be s scliced
global function right_fromright(sequence s,atom p)
	atom len,p1	
	len=length(s)
	p1=len-p+1
	if p1>len then return {} end if
	if p1<0 then return s end if
	return s[p1..len]
end function

--TESTED WORKS
--returns string that is from position p to length of s, including p
global function right(sequence s,atom p)
	atom len
	len=length(s)
	if p>len then return {} end if
	if p<0 then return s end if
	return s[p..len]
end function

--TESTED WORKS
--returns string that is only to position p of s, including p
global function left(sequence s,atom p)
	if p>length(s) then return s end if
	if p<0 then return {} end if
	return s[1..p]
end function



global function TSStr_File_SplitPath( sequence path )
	--/ Path: Path spec to breakdown
	--/ Returns a sequence with the drive, each dir, root, and ext as separate sequences
object ds
integer slash

ds = {}      -- make ds {} for when path is empty
slash = 1    -- initialize slash

if length(path) > 0 then                       -- do nothing with zero length

    if compare(path[1],'\\')=0 then            -- strip first \
      path=path[2..length(path)]
    end if

  if length(path) > 1 then                     -- strip end \
    if compare(path[length(path)],'\\')=0 then
      path=path[1..length(path)-1]
    end if
  end if

  if length(path) > 0 then
    ds = {{}} -- make space for first dir, then remove first and last slash
    while slash > 0 do                       -- keep going while 2+ dirs exist
      slash = match("\\",path)               -- look for slash ie. 2+ dirs
        if slash > 0 then                    -- is there 2 or more dirs?
          ds[length(ds)] = path[1..slash-1]  -- add dir to end of dir split
          ds = ds & {"ERROR"}                -- add extra space for next dir
          path = path[slash+1..length(path)] -- remove first dir from path
        end if
    end while

    if length(ds) > 0 then
      ds[length(ds)] = path                      -- 1 dir (no slash) so add it
    end if
 end if

end if
return ds
end function --SpecItems


--if two elements or more in sequence are same 
--it leaves just one of them
global function TsSeq_DeleteDuplicated(sequence s)
	sequence ret
	ret={}
	for i=1 to length(s)do
		if find(s[i],ret)=0 then
			ret=append(ret,s[i])
		end if
	end for
	return ret
end function

---------------------------------------------------------------------------
--finds string in sequence of strings and it doesn't match case (A=a)
--returns position where found else 0
---------------------------------------------------------------------------
global function TSSeq_FindStrInSeq_NoCase(sequence s,sequence sub)
	sequence sub_low

	sub_low=lower(sub)

	for i=1 to length(s) do
		if equal(lower(s[i]),sub_low) then
			return i
		end if
	end for

	return 0
end function

---------------------------------------------------------------------------
--if two elements or more in sequence are same 
--it leaves just one of them
--it doesnt match case
---------------------------------------------------------------------------
global function TsSeq_DeleteDuplicated_NotCase(sequence s)
	sequence ret
	ret={}
	for i=1 to length(s)do
		if TSSeq_FindStrInSeq_NoCase(ret,s[i])=0 then
			ret=append(ret,s[i])
		end if
	end for
	return ret
end function


--returns sequence that has members which ARE in s1 and AREN'T in s2
global function TSSeq_GetDifferent(sequence s1,sequence s2)
	sequence ret
	ret={}
--	show("s2",s2)
	for i=1 to length(s1)do
--		show("s1[i]",s1[i])
--		wait()
		if find(s1[i],s2)=0 then
			ret=append(ret,s1[i])
		end if
	end for
	return ret
end function 

--TESTED WORKS
--insert sequence of text into sequence of text at position
--at position 'col'
global function TSTxtLns_Insert(sequence txtLns,
	sequence txtLnsIns,atom ln,atom col)

	sequence middle,leftFirst

--	shown("ln",ln)
--	shown("col",col)

	--add first line
	leftFirst=txtLns[ln][col..length(txtLns[ln])]
	txtLns[ln]=txtLns[ln][1..col-1] & txtLnsIns[1]	
	--add lines between
	middle=txtLnsIns[2..length(txtLnsIns)]
	txtLns=TSSeq_InsertSequence(txtLns,middle,ln+1)
	--add last line
	txtLns[ln+length(middle)]&=leftFirst
	return txtLns 
end function


--TESTED WORKS
--deletes
global function TSTxtLns_Delete(sequence txtLns,
	atom ln1,atom col1,atom ln2,atom col2)
		
	atom begin

--	shown("\nln1",ln1)
--	shown("col1",col1)
--	shown("ln2",ln2)	
--	shown("col2",col2)

	begin=ln1+1
	
	--lines that are not full deleted
	if ln1=ln2 then
		txtLns[ln1]=TsSeq_Eliminate(txtLns[ln1],col1,col2)
		return txtLns	
	else
		txtLns[ln1]=TsSeq_Eliminate(txtLns[ln1],col1,length(txtLns[ln1]))
		--add last line
		txtLns[ln1]&=mid(txtLns[ln2],col2+1,
			length(txtLns[ln2]))		
	end if	

	--delete other lines
	--here deleted only full lines
	txtLns=	TsSeq_Eliminate(txtLns,begin,ln2)
--	for i=begin to ln2 do
		--ts("eliminating line " & txtLns[begin])
		--shown("i",i)
--		txtLns=TsSeq_Eliminate(txtLns,begin,begin)		
--	end for

	return txtLns
end function

--TESTED WORKS
--extracts slice and returns as STRING
global function TSTxtLns_GetSlice(sequence txtLns,
	atom ln1,atom col1,atom ln2,atom col2)
		
	atom i
	sequence ret
	ret={}

	--get first line
	if ln1=ln2 then
		ret=TsSeq_Extract(txtLns[ln1],col1,col2)
--		shown("col1",col1)
--		shown("col2",col2)
		--ts("IA")
		return ret
	else
		ret=TsSeq_Extract(txtLns[ln1],col1,length(txtLns[ln1]))
	end if	

	--get other lines
	i=ln1+1
	while 1 do
		if i>=ln2 then			
			exit
		end if
		ret&="\n"
		ret&=txtLns[i]--TsSeq_Extract(txtLns,i,i)		
		i+=1
	end while

	--get last line
	ret&="\n"
	ret&=mid(txtLns[ln2],1,col2)

	return sequence_to_string(ret)
end function



--TESTED WORKS
--extracts slice and returns as LINES OF TEXT
global function TSTxtLns_GetSliceLines(sequence txtLns,
	atom ln1,atom col1,atom ln2,atom col2)

	atom i
	sequence ret
	ret={}

	--get first line
	if ln1=ln2 then
		ret={TsSeq_Extract(txtLns[ln1],col1,col2)}
		return ret
	else
		ret={TsSeq_Extract(txtLns[ln1],col1,length(txtLns[ln1]))}
	end if	

	--get other lines
	i=ln1+1
	while 1 do
		if i>=ln2 then			
			exit
		end if		
		ret&=TsSeq_Extract(txtLns,i,i)
		i+=1
	end while

	--get last line	
	ret=append(ret,mid(txtLns[ln2],1,col2))

	return ret
end function

--finds character in liines of text
--from line 'begln' and column in that line
--'begcol' in lines of text 's'
--returns {ln,col} if found or
--{0} if not found
global function TSTxtLns_FindCharIn(sequence s,
	integer char,atom begln,atom begcol)

	integer c
	
	for line=begln to length(s)do
		for column=begcol to length(s[line])do
			c=s[line][column]
			show("c",c)
			if c=char then
				return {line,column}
			end if
			begcol=1
		end for
	end for

	return {0}
end function


global function TSTxtLns_FindNONSpace(sequence s,
	atom begln,atom begcol)

	integer c
	
	for line=begln to length(s)do
		for column=begcol to length(s[line])do
			c=s[line][column]
			--show("c",c)
			if isspace(c)=0 then
				return {line,column}
			end if
			begcol=1
		end for
	end for

	return {0}
end function


--finds non space character ( NOT:' ' , '\n', '\t') in sting from postion
--DIFFERENCE form FindNONSpaceInString : 
--	returns length(s)+1 if in string all spaces
global function FindNONSpaceInString2(sequence str,atom pos,atom way)
--DESCRIPTION:if space not found returns 0
--else returns position where char is in string
--str-string in which searching
--'ch-char searching for
--'pos-position in string where to start
--'way- 1 or -1, if 1 searches forward, if -1 backwards

atom i,cc

	i=pos

	while 1 do
		if(i>length(str))then exit end if
		if(i<1)then exit end if

		cc=str[i]
		if(isspace(cc)=0)then return i end if

		i=i+way
	end while

return length(str)+1

end function

--TESTED
--returns spaces that are on the start of the string
--or "" if none
--"   pain"
--returns "   "
--s is regular text
global function TSStr_GetLeadingSpaces(sequence s)
	atom p
	p=FindNONSpaceInString2(s,1,1)
	if p=0 then
		return ""
	end if
	return s[1..p-1]
end function


--if s ="12345" or "1.2456" or "1,55645"
--return true
--else return false
global function AreJustDigits(sequence s)
	integer founddigit
	founddigit=0
	for i=1 to length(s) do
		if isdigit(s[i])then
			founddigit=1
		elsif s[i]='.' or s[i]=',' and founddigit=1 then
		else
			return 0
		end if
	end for

	return 1
end function

--if "1234" or "1.23" or "1,234" or "123Bf" 
--or -134 return true
--if "bdwy4" .. return false
global function TSStr_IsWordDigit(sequence s)
	integer founddigit
	atom lens

	lens=length(s)
	if lens<1 then return 0 end if

	if isdigit(s[1]) then return true end if
	if s[1]='-' then
		if lens>=2 then
			if isdigit(s[2])then
				return true
			end if
		end if
	end if
	
	founddigit=0
	for i=1 to length(s) do
		if isdigit(s[i])then
			founddigit=1
		elsif s[i]='.' or s[i]=',' and founddigit=1 then
		else
			return 0
		end if
	end for

	return 1
end function



-----------------------------------------------------------------------------
global function instr( integer n, sequence s1, sequence s2 )

    -- return position of s1 in s2, starting at position n

    integer at

    at = match( s1, s2[n..length(s2)] )
    if at != 0 then
	return at + n - 1
    else
	return 0
    end if

end function

--s : regular text
--returns positions where words in s are
--scands thru text and returns positions where words are
-----------------------------------------------------------------------------
global function TSStr_CollectWords(sequence s,sequence word)
	sequence ret,newword
	atom wordlen
	ret={}
	wordlen=length(word)
	
	for i=1 to length(s)do
		if i+wordlen-1>length(s)then
			exit
		end if
		newword=s[i..i+wordlen-1]
		--show("newword",newword)
		if equal(newword,word)then	
			ret=append(ret,i)
		end if
	end for

	return ret
end function



--tl : lines of text
--returns array:
--1.atom : ln num
--2.sequence : col NUMS of start of word, all columns in that line, at least one
--scands thru text and returns positions where words are
-----------------------------------------------------------------------------
global function TSTxtLns_CollectWords(sequence tl,sequence word)
	sequence ret,columns
	ret={}
	
	for line=1 to length(tl)do
		columns=TSStr_CollectWords(tl[line],word)
		if length(columns) then
			ret=append(ret,{line,columns})
		end if
	end for

	return ret
end function


--returns {line,column} or {0,0} if not found
--------------------------------------------------------------------------------------
global function TSTxtLns_GetMatchingWordForward(
	sequence txtlns,sequence s1,sequence s2,
	atom sline,atom scol,
	atom minline,atom maxline)

	sequence fw1,fw2,txt
	atom s1len,s2len,n1,n2

	s1len=length(s1)
	s2len=length(s2)
	n1=0
	n2=0
	
	for line = sline to length(txtlns)do
--		shown("line",line)
--		shown("maxline",maxline)
		--wait()
		if line<minline or line > maxline then
			return {0,0}
		end if
		txt=txtlns[line]
		for i=scol to length(txt)do
			fw1=mid(txt,i,i+s1len-1)
			fw2=mid(txt,i,i+s2len-1)
--			show("fw1",fw1)
--			show("fw2",fw2)
			if equal(fw1,s1)then
				n1+=1
--				if n1=n2 then
--					return{0,0}
--				end if
			end if
			if equal(fw2,s2)then
				n2+=1
				if n2>=n1 then
					return{line,i}
				end if
			end if
		end for
		scol=1
	end for

	return {0,0}
end function



--returns {line,column} or {0,0} if not found
--------------------------------------------------------------------------------------
global function TSTxtLns_GetMatchingWordBack(
	sequence txtlns,sequence s1,sequence s2,
	atom sline,atom scol,
	atom minline,atom maxline)

	sequence fw1,fw2,txt
	atom s1len,s2len,n1,n2

	s1len=length(s1)
	s2len=length(s2)
	n1=0
	n2=0
	
	for line = sline to 1 by -1 do
		if line<minline or line > maxline then
			return {0,0}
		end if
		txt=txtlns[line]
		if line!=sline then
			scol=length(txt)
		end if
		for i=scol to 1 by -1 do
			fw1=mid(txt,i,i-s1len+1)
			fw2=mid(txt,i,i-s2len+1)
--			show("fw1",fw1)
--			show("fw2",fw2)
			if equal(fw1,s1)then
				n1+=1
--				if n1=n2 then
--					return{0,0}
--				end if
			end if
			if equal(fw2,s2)then
				n2+=1
				if n2>=n1 then
					return{line,i}
				end if
			end if
		end for		
	end for

	return {0,0}
end function


--returns {line,column} or {0,0} if not found
--------------------------------------------------------------------------------------
function TSTxtLns_GetMatchingWordForward_FirstFree(
	sequence txtlns,sequence s1,sequence s2,
	atom sline,atom scol,
	atom minline,atom maxline)

	sequence fw1,fw2,txt
	atom s1len,s2len,n1,n2

	s1len=length(s1)
	s2len=length(s2)
	n1=0
	n2=0
	
	for line = sline to length(txtlns)do
--		shown("line",line)
--		shown("maxline",maxline)
		--wait()
		if line<minline or line > maxline then
			return {0,0}
		end if
		txt=txtlns[line]
		for i=scol to length(txt)do
			fw1=mid(txt,i,i+s1len-1)
			fw2=mid(txt,i,i+s2len-1)
--			show("fw1",fw1)
--			show("fw2",fw2)
			if equal(fw1,s1)then
				n1+=1
--				if n1=n2 then
--					return{0,0}
--				end if
			end if
			if equal(fw2,s2)then
				n2+=1
				if n2>n1 then --!!!the only change '>' instead of '>='
					return{line,i}
				end if
			end if
		end for
		scol=1
	end for

	return {0,0}
end function




--returns:
--1.ln and col where first brace 
--2.ln and col where last brace 
--if not in brace returns {{0}}
--arg minline, maxline : limits till where searching
---------------------------------------------------------------------------
global function TSTxtLns_GetBraceWeAreIn(
	sequence txtlns,
	sequence leftbrace,sequence rightbrace,
	atom ln,atom col,atom
	minline,atom maxline)

	sequence forw,back
	sequence fw1,fw2,txt
	atom leftbracelen,rightbracelen,n1,n2
	

	forw=TSTxtLns_GetMatchingWordForward_FirstFree(
		txtlns,leftbrace,rightbrace,
		ln,col,minline,maxline)



	if forw[1] then
		back=TSTxtLns_GetMatchingWordBack(
			txtlns,rightbrace,leftbrace,
			forw[1],forw[2],minline,maxline)
	else return {{0}}
	end if

	if back[1] then
		return{back,forw}
	else
		return{{0}}
	end if

end function


constant part_of_word="_"

--returns true if yes, else false
--abc	= true
--a1	= true
--abc#@	= false
--1a	= false
--123	= false
--@#	= false
global function TSStr_IsWordNormal(sequence s)
	
	--first word must be alpha
	if length(s)>=1 
		and isalpha(s[1])=false 
		and find(s[1],part_of_word)=0 then

		return false
	end if

	for i=1 to length(s)do
		if isalpha(s[1])=false
		and isdigit(s[1])=false
		and find(s[1],part_of_word)=0 then
			return false
		end if
	end for

	return true
end function



--global function TSTxtLns_Merge(
--	sequenece tlorig,
--	sequence tlaround
--	)



---------------------------------------------------------------------------
--in stirng s replaces all occurances of old substrings with new substrings
--It doesn't match case, (A=a)
---------------------------------------------------------------------------
global function TSStr_Replace_DontMatchCase(sequence s,sequence old,sequence new)
	sequence r		--result returned
	integer oldlenm,newlen
	sequence tmpword,lowold
	integer theend
	integer i

	i=1
	oldlenm=length(old)-1
	newlen=length(new)
	theend=length(s)-oldlenm
	if theend<1 then
		return s
	end if
	r=""
	lowold=lower(old)

	
	while i<=theend do
		tmpword=lower(s[i..i+oldlenm])
		if equal(tmpword,lowold)then
			r&=new
			i+=oldlenm
		else
			r&=s[i]
		end if
		i+=1
	end while

	r&=s[theend+1..length(s)]

	return r
end function



---------------------------------------------------------------------------
--from "C:\igre\file.txt" returns "file.txt"
---------------------------------------------------------------------------
global function TSStr_File_GetName(sequence path)
	atom p1	
	p1=FindCharInString(path,'\\',length(path),-1)
	if(p1<1)then p1=0 end if
	return(path[p1+1..length(path)])	
end function





---------------------------------------------------------------------------
--from "C:\igre\new\file.txt" returns "new"
--or from "c:\igre\new" returns "new"
--or from "file.txt" returns last dir. of current directory
--arg. full *file* (not directory) name
---------------------------------------------------------------------------
global function TSStr_File_GetLastDir(sequence path)
	integer p1,p2
	sequence curdir

	p1=FindCharInString(path,'\\',length(path),-1)

	if p1>0 then
		p2=FindCharInString(path,'\\',p1-1,-1)
	else
		p2=0
	end if

	if p1>0 and p2>0 then			--"C:\\igre\\new\\file.txt"
		return path[p2+1..p1-1]
	
	elsif p1>0 and p2<=0 then	--"C:\\new\\file.txt" 
		return path[1..p1-1]
	else						--"file.txt"
		curdir=current_dir()
		p1=FindCharInString(curdir,'\\',length(curdir),-1)
		if p1>0 then				--"C:\\igre\\new"
			return curdir[p1+1..length(curdir)]
		else					--"C" (drive)
			return curdir
		end if		 
	end if

	return ""
end function


---------------------------------------------------------------------------
--returns starting spaces of string
--from "     text" returns "     "
--use TSStr_GetLeadingSpaces instead
---------------------------------------------------------------------------
--global function TSStr_GetStartSpaces(sequence str)
--	integer last,i
--
--	last=0
--	i=1
--
--	while 1 do
--		if i>=length(str) then
--			last=length(str)
--			exit
--		end if
--		if isspace(str[i])=0then
--			last=i-1
--			exit
--		end if
--		i+=1
--	end while
--	
--	return str[1..last]
--end function